if not (type(OneRingLib) == "table" and type(OneRingLib.CreateRing) == "function") then
	return;
end

local floor = math.floor

local function generateColor(c, n)
	local hue, v, s = (15+(c-1)*360/n)%360, 1, 0.85;

	local h = floor(hue/60) % 6;
	local f = (hue/60) % 1;
	local p, q, t = v - v * s, v - v * f * s, v - v*s + v * f * s;
	if h == 0 then return v, t, p;
	elseif h == 1 then return q, v, p;
	elseif h == 2 then return p, v, t;
	elseif h == 3 then return p, q, v;
	elseif h == 4 then return t, p, v;
	elseif h == 5 then return v, p, q;
	end
end

do
	local rname, rdesc, ringID = "OPieEquipmentManager", {name = "Equipment Manager", hotkey = "ALT-G"}

	local function ringClicked(ring, set)
		EquipmentManager_EquipSet(set)
	end

	local function UpdateSets()
		local n = GetNumEquipmentSets()
		for i = 1, n do
			local name, icon = GetEquipmentSetInfo(i)
			rdesc[i] = rdesc[i] or {}
			rdesc[i][1], rdesc[i][2], rdesc[i][3], rdesc[i].icon, rdesc[i].caption = "func", ringClicked, name, icon, "Equip " .. name
			rdesc[i].r, rdesc[i].b, rdesc[i].g = generateColor(i, n)
		end
		for i = n + 1, #rdesc do
			rdesc[i] = nil
		end
		OneRingLib:SetRingData(ringID, rdesc)
	end

	ringID = OneRingLib:CreateRing(rname, rdesc)
	EC_Register("PLAYER_LOGIN", "OPie.EquipmentManager", function()
		UpdateSets()
	end);
	EC_Register("EQUIPMENT_SETS_CHANGED", "OPie.EquipmentManager", function()
		UpdateSets()
	end);
end
